from commons.core.coord.Path import Path
    
class MatchingSubject(Path):
    
    ## Constructor
    #
    # @param id identifier
    # @param range_q a Range instance for the query
    # @param range_s a Range instance for the subject
    # @param e_value float E-value of the match 
    # @param score integer score of the match
    # @param identity float identity percentage of the match
    # @param length integer length of the subject
    #
    def __init__(self, path = Path(), length = -1):
        self._length = length
        Path.__init__(self, path.id, path.range_query, path.range_subject, path.e_value, path.score, path.identity)
        
    def getProteinDomainLength(self):
        return self._length
    
    def setProteinDomainLength(self, length):
        self._length = length