#!/usr/bin/env python


import tarfile, shutil, os
from optparse import OptionParser


class Untar(object):

	def __init__(self):
		self._dirForGalaxy = ""
		self._fileName = ""
		self._id = ""

	def setDirForGalaxy(self, dirName):
		self._dirForGalaxy = dirName

	def getDirForGalaxy(self):
		return self._dirForGalaxy

	def setFileName(self, dirName):
		self._fileName = dirName

	def getFileName(self):
		return self._fileName

	def setId(self, ID):
		self._id = ID

	def getId(self):
		return self._id

	def setAttributesFromCmdLine(self):
		parser = OptionParser(description = "untar a tar file for Galaxy", version = "v1.0")
		parser.add_option( "-d", "--dir", dest = "dir", help = "dir for Galaxy")
		parser.add_option( "-t", "--tar", dest = "tar", help = "tar file name")
		parser.add_option( "-i", "--id", dest = "id", help = "Galaxy id")
		parser.add_option( "-l", "--log", dest = "log", help = "log")
		options, args = parser.parse_args()
		fh = open(options.log, "w")
		fh.write("You need to refresh Galaxy History to see the output files")
		fh.close()
		self._setAttributesFromOptions(options)

	def _setAttributesFromOptions(self, options):
		self.setDirForGalaxy(options.dir)
		self.setFileName(options.tar)
		self.setId(options.id)

	def run(self):
		tar = tarfile.open(self.getFileName(), "r")
		for tarinfo in tar:	
			name = tarinfo.name
			tar.extract(name, path=self.getDirForGalaxy())
			baseName = os.path.basename(name)	
			split = os.path.splitext(baseName)
			alias =split[0].replace("_", "")
			ext = split[1].strip(".")
			shutil.move("%s/%s" % (self.getDirForGalaxy(), name) , "%s/primary_%s_%s_visible_%s" % (self.getDirForGalaxy(), self.getId(), alias, ext))	

if __name__ == "__main__":
	untar = Untar()
	untar.setAttributesFromCmdLine()
	untar.run()	
