#!/usr/bin/env python

import os
startupfilename = os.environ.get('PYTHONSTARTUP')
if startupfilename and os.path.isfile(startupfilename):
    execfile(startupfilename)

import sys
import getopt
from commons.core.sql.DbFactory import DbFactory


def help ():
    print "usage:",sys.argv[0],"[options]"
    print "options:"
    print "    -h: this help"
    print "    -f: grouper out file.map"
    print "    -t: map table"
    print "    -x: max copies number,(default=10)"
    

def main ():
    map_file=""
    map_table=""
    maxcopy=10
    verbosity = 0
    
    opts,args = getopt.getopt(sys.argv[1:],"hf:x:t:")
    for o,a in opts:
        if o == "-h":
            help()
        if o == "-f":
            map_file=a 
        if o == "-t":
            map_table=a 
        if o == "-x":
            try:
                maxcopy=int(a) 
            except ValueError:
                print "ValueError: invalid literal for int() "
                help()

            
    if map_file=="":
        help()
        return

    #######################
    # DATABASE CONNECTION #
    #######################
    iDB=DbFactory.createInstance()



    #################################
    #  Create out table: map_table  #
    #################################
#    size=len(map_file.split("/"))
#    table_name=map_file.split("/")[size-1].split(".group.c0.map")[0]
#    map_table=table_name+"_map"
    iDB.createTable(map_table, "map", map_file, True)
#    os.system("srptCreateTable.py -f "+map_file+" -n "+map_table+" -t map")
    table_name = map_table


    #############################
    #   Create cluster list     #
    #############################
    if verbosity > 1:
        print "\nCreate cluster list "
        print "******************************************************************************\n"
    iDB.execute('select name from %s'%(map_table))
    list=iDB.fetchall()
    cluster_list=[]
    for I in list :
        cluster=int(I[0].split("Gr")[1].split("Cl")[0])
        if cluster_list.count(cluster)==0:
            cluster_list.append(cluster)
            
    
    #########################################################
    #      Select cluster according their max copy number   #
    #########################################################
    if verbosity > 1:
        print "\nSelect clusters according their max copy number"
        print "******************************************************************************\n"
        print "\nSelect clusters with "+str(maxcopy)+" copy number  ......"


    # CREATE TABLES ACCORDING TO TREE CLASS ( 2 copies / 3 to max copies number / more than max copies number )
    #create='create table %s (name char(255),chr char(255),start bigint(21),end bigint(21),index cse (chr,start,end));'

    dico2={}
    table2=table_name+"_2"
    iDB.createTable(table2, "map", "", True)

    dicol3tomaxcopy={}
    table3tomax=table_name+"_3to"+str(maxcopy)
    iDB.createTable(table3tomax, "map", "", True)

    dicomaxcopy={}
    maxtable=table_name+"_more"+str(maxcopy)
    iDB.createTable(maxtable, "map", "", True)

    # CLASSIFICATION OF EACH CLUSTER
    for cluster in cluster_list:
#        select='select * from %s where name like "%%Gr%dCl%d%%";'
        select='select * from %s where name like "%%Gr%dCl%%";'
        sql=select%(map_table,cluster)
        iDB.execute(sql)
        result=iDB.fetchall()
        
        select='select count(*) from %s where name like "%%Gr%dCl%%";'
        sqlcluster=select%(map_table,cluster)
        iDB.execute(sqlcluster)
        nbcopy=int(iDB.fetchall()[0][0])
        
        
        #( exactly 2 copies) 
        if nbcopy == 2 :
            if not dico2.has_key(cluster):
                dico2[cluster]=result
                
        #( 3 to max copies)         
        if nbcopy > 2 and nbcopy <= maxcopy :
            if not dicol3tomaxcopy.has_key(cluster):
                dicol3tomaxcopy[cluster]=result
                
        #( more than maxcopy copies) 
        if nbcopy > maxcopy :
            if not dicomaxcopy.has_key(cluster):
                dicomaxcopy[cluster]=result


    # INSERT INTO TABLES
    for I in dico2.keys() :
        for i in range(0,len(dico2[I])):
            insert='insert into %s values ("%s","%s",%d,%d);'
            sql=insert%(table2,dico2[I][i][0],dico2[I][i][1],int(dico2[I][i][2]),int(dico2[I][i][3]))
            iDB.execute(sql)
            
    for I in dicol3tomaxcopy.keys() :
        for i in range(0,len(dicol3tomaxcopy[I])):
            insert='insert into %s values ("%s","%s",%d,%d);'
            sql=insert%(table3tomax,dicol3tomaxcopy[I][i][0],dicol3tomaxcopy[I][i][1],int(dicol3tomaxcopy[I][i][2]),int(dicol3tomaxcopy[I][i][3]))
            iDB.execute(sql)
    
    for I in dicomaxcopy.keys() :
        for i in range(0,len(dicomaxcopy[I])):
            insert='insert into %s values ("%s","%s",%d,%d);'
            sql=insert%(maxtable,dicomaxcopy[I][i][0],dicomaxcopy[I][i][1],int(dicomaxcopy[I][i][2]),int(dicomaxcopy[I][i][3]))
            iDB.execute(sql)
            
if __name__ == "__main__": 
    main ()
