#!/usr/bin/env python

import user, os, sys, getopt, exceptions, re

#-----------------------------------------------------------------------------

def help():

        print "\nusage:",sys.argv[0]," [ options ]"
        print "option:"
        print "    -h: this help"
        print "    -i: input out file (output from RepeatMasker)"
	print "output file = <input file>.path"
	print "matchs on queries on direct or complement strand"
	print "matchs on subjects always on direct strand"
	print "score from Smith-Waterman algorithm"

#-----------------------------------------------------------------------------

def main():

    inFileName = ""

    try:
        opts, args = getopt.getopt(sys.argv[1:],"hi:")
    except getopt.GetoptError:
        help()
        sys.exit(1)
    for o,a in opts:
        if o == "-h":
            help()
            sys.exit(0)
        if o == "-i":
            inFileName = a

    if inFileName == "":
        print "*** Error: missing input file name"
        help()
        sys.exit(1)

    dHSPs = {}
    outFile = open( inFileName + ".path", "w" )

    inFile = open( inFileName, "r" )
    line = inFile.readline()

    dID2count = {}
    count = 1
    emptyLine = 1

    while 1:

        line = line.split()

	# check if the line is empty (continue the 1st time, stop the 2nd time)
        if len(line) == 0:
	    if emptyLine == 1:
	        emptyLine += 1
		line = inFile.readline()
		continue
	    else:
		break

	# check if the line corresponds to a match
        try:
            test = int(line[0])
        except ValueError:
	    line = inFile.readline()
            continue

        score = line[0]
	percDiv = line[1]
	percDel = line[2]
	percIns = line[3]
	qryName = line[4]
	qryStart = line[5]
	qryEnd = line[6]
	qryLeft = line[7]
	strand = line[8]
	sbjName = line[9]

	reg = re.compile( "^\(-?[0-9]+\)$" )

        if line[8] == "+":   # if match with direct subject
	    qryStart = line[5]
	    qryEnd = line[6]
            if reg.search( line[12] ) != None:   # if (left) column
	        sbjStart = line[10]
		sbjEnd = line[11]
                RMid = line[13]
            else:
                sbjStart = line[11]
		sbjEnd = line[12]
                RMid = line[14]

        elif line[8] == "C":   # if match with complement subject
	    qryStart = line[6]
	    qryEnd = line[5]
            if reg.search( line[10] ) != None:   # if (left) column
                sbjStart = line[12]
		sbjEnd = line[11]
                RMid = line[13]
            else:
                sbjStart = line[13]
		sbjEnd = line[12]
                RMid = line[14]

        percId = 100 - float(percDiv)

	# A part of RepeatMasker does the same as Matcher
	# thus 2 matches can have the same ID
	# moreover, the same ID can be used on 2 different chunks
	# hence we need a dictionary
        key_id = RMid + "-" + qryName + "-" + sbjName
	if key_id not in dID2count.keys():
	    path = count
	    count += 1
	    dID2count[ key_id ] = path
	else:
	    path = dID2count[ key_id ]

        data = str(path) + "\t" + qryName + "\t" + qryStart + "\t" + qryEnd + "\t"
	data += sbjName + "\t" + sbjStart + "\t" + sbjEnd + "\t0.0\t"
	data += str(score) + "\t" + str(percId) + "\n"

        outFile.write( data )

        line = inFile.readline()

    inFile.close()
    outFile.close()

    return 0

#-----------------------------------------------------------------------------

if __name__ == "__main__": 
    main ()
