#!/bin/bash

if [[ $# -eq 0 ]];
    then
	echo "usage:" $0 "<pipeline configuration file>";
	exit 1;
    fi;

. $1

if [[ -z $RMBLR_table ]]; then
    echo "no RMBLR_table variable defined"
    exit 1
fi
if [[ -z $SSR_table ]]; then
    echo "no SSR_table variable defined"
    exit 1
fi
echo ${onchr_table}
if [[ -z $onchr_table ]]; then
    echo "no onchr_table variable defined"
    exit 1
fi
echo ${chunk_map}
if [[ -z $chunk_map ]]; then
    echo "no chunk_map variable defined"
    exit 1
fi
echo ${chunk_seq}
if [[ -z $chunk_seq ]]; then
    echo "no chunk_seq variable defined"
    exit 1
fi

echo "Remove spurious hits"
srptRemoveSpurious.py -q ${RMBLR_table} -s ${SSR_table} -t path/path
echo "Convert to chr"
srptConvChunk2Chr.py -m ${chunk_map} -q ${RMBLR_table}_noSSR -t path -c
echo "Rename table"
srptRenameTable.py -t ${RMBLR_table}_noSSR_onchr -n ${onchr_table}
echo "Join path"
srptJoinPath.py -t ${onchr_table} > ${onchr_table}.joinPath.out
echo "Get sequences"
srptGetSeqFromTable.py -q ${onchr_table}_joined -m ${chunk_map} -s ${chunk_seq} -t path
