#!/usr/bin/env bash

if [[ $# -ne 1 ]];
    then
        echo "usage:" $0 "<config filename>";
        exit 1;
    fi;

. $1

chk_dir_name=`echo $chunk_dir | sed s/"\/$"// | awk -F"/" '{print $(NF)}'`
echo ${chk_dir_name}

#-----------------------------------------------------------------

BLRtx () {
blaster -P -W -n tblastx -q $db_dir/$RUlib -B $db_dir/${RUlib}-BLRtxPrepare 
if [[ ! -e BLRtx ]]; then
mkdir BLRtx
fi
cd BLRtx
srptBLR.py -b BLRtx -B " -W" -t jobs -d ${cluster_db_dir} -q ${chk_dir_name} -s ${RUlib} -g BLRtx_RU -Q $queue_name
cd ..
}

#-----------------------------------------------------------------

BLRa () {
blaster -P -W -n blastn -q $db_dir/${geno_db} -B $db_dir/${geno_db}-BLRtxPrepare 
if [[ ! -e BLRa ]]; then
mkdir BLRa
fi
cd BLRa
srptBLR.py -b BLRa -B " -W" -t jobs -d ${cluster_db_dir} -q ${chk_dir_name} -s ${geno_db} -g BLRa -Q $queue_name
#rm ${geno_db}.BLRa.align > /dev/null
#for i in *.align
#do
#  cat $i >> ${geno_db}.BLRa.align
#done
grouper -m ${geno_db}.BLRa.align -q $db_dir/${geno_db} -j -E 1e-300
matcher -m ${geno_db}.BLRa.align -q $db_dir/${geno_db} -a -j -E 1e-300
cd ..
}

#-----------------------------------------------------------------

cd $root_dir

#BLRtx
BLRa
