#!/usr/bin/env bash

#-----------------------------------------------------------------

RMSSR () {
mkdir RMSSR
cd RMSSR
if [[ -e ${chunk_prefix}_RMSSR.path ]]; then
return 
fi
srptRMSSR.py -t jobs -d ${db_dir} -q ${chk_dir_name} -g RMSSR -Q $queue_name
mv RMSSR.RMSSR.path ${chunk_prefix}_RMSSR.path
cp ${chunk_prefix}_RMSSR.path ..
cd ..
srptCreateTable.py -f ${chunk_prefix}_RMSSR.path -n ${chunk_prefix}_RMSSR_path -t path
}

#-----------------------------------------------------------------

mreps () {
if [[ ! -e SSRmreps ]]; then
mkdir SSRmreps
fi
cd SSRmreps
if [[ -e ${chunk_prefix}_mreps_SSR.set ]]; then
return 
fi
for i in ${chunk_dir}/chunk*.fa
  do
  file=`echo $i | awk -F"/" '{print $(NF)}' `
  echo $file
  ln -s $i
  mreps.py $file
  rm $file
done
cat *.mreps.set > ${chunk_prefix}_mreps_SSR.set_tmp
setnum2id.awk ${chunk_prefix}_mreps_SSR.set_tmp > ${chunk_prefix}_mreps_SSR.set
rm ${chunk_prefix}_mreps_SSR.set_tmp
cp ${chunk_prefix}_mreps_SSR.set ..
cd ..
srptCreateTable.py -f ${chunk_prefix}_mreps_SSR.set -n ${chunk_prefix}_mreps_SSR_set -t set
}

#-----------------------------------------------------------------

trf () {
if [[ ! -e SSRtrf ]]; then
mkdir SSRtrf
fi
cd SSRtrf
if [[ -e ${chunk_prefix}_trf_SSR.set ]]; then
return 
fi
for i in ${chunk_dir}/chunk*.fa
  do
  file=`echo $i | awk -F"/" '{print $(NF)}' `
  echo $file
  ln -s $i
  trf.py $file
  rm $file
  mv SSRtrf.set $file.trf.set
done
cat *.trf.set > ${chunk_prefix}_trf_SSR.set_tmp
setnum2id.awk ${chunk_prefix}_trf_SSR.set_tmp > ${chunk_prefix}_trf_SSR.set
rm ${chunk_prefix}_trf_SSR.set_tmp
cp ${chunk_prefix}_trf_SSR.set ..
cd ..
srptCreateTable.py -f ${chunk_prefix}_trf_SSR.set -n ${chunk_prefix}_trf_SSR_set -t set
}

#-----------------------------------------------------------------
#-----------------------------------------------------------------

if [[ $# -ne 1 ]];
    then
        echo "usage:" $0 "<config filename>";
        exit 1;
    fi;

. $1

date

chk_dir_name=`echo $chunk_dir | sed s/"\/$"// | awk -F"/" '{print $(NF)}'`
cdir=`pwd`

if [[ ! -e ${SSR_dir} ]]; then
mkdir ${SSR_dir}
fi
cd ${SSR_dir}

#RMSSR
#mreps
#trf

#echo "${chunk_prefix}_trf_SSR_set	set	merge">mergeSSR.txt
#echo "${chunk_prefix}_mreps_SSR_set	set	merge">>mergeSSR.txt
#echo "${chunk_prefix}_RMSSR_path	path	merge">>mergeSSR.txt

srptAutoPromote.py -f mergeSSR.txt -r $SSRtable

cd $cdir

echo $0 " finished successfully !"
date
