#!/bin/bash

if [[ $# -eq 0 ]];
    then
	echo "usage:" $0 "<path table name>";
	exit 1;
    fi;

RMBLR_table=$1

echo ${RMBLR_table}

srptConv2range.py -q ${RMBLR_table} -t path
mysql -h $REPET_HOST -p"mobilet" $REPET_DB <<EOF

create temporary table ${RMBLR_table}_range2 select * from ${RMBLR_table}_range;
drop table if exists ${RMBLR_table}_doublons;
create table ${RMBLR_table}_doublons 
select ${RMBLR_table}_range.path as path_to_rm, ${RMBLR_table}_range2.path 
,${RMBLR_table}_range.query_name,${RMBLR_table}_range.subject_name
,${RMBLR_table}_range.query_start as qstart1,${RMBLR_table}_range2.query_start as qstart2 
,${RMBLR_table}_range.query_end as qend1,${RMBLR_table}_range2.query_end as qend2
,${RMBLR_table}_range.subject_start as sstart1,${RMBLR_table}_range2.subject_start as sstart2
,${RMBLR_table}_range.subject_end as send1,${RMBLR_table}_range2.subject_end as send2
from ${RMBLR_table}_range, ${RMBLR_table}_range2
where ${RMBLR_table}_range.query_name=${RMBLR_table}_range2.query_name 
and ${RMBLR_table}_range.subject_name=${RMBLR_table}_range2.subject_name 
and ${RMBLR_table}_range.query_start=${RMBLR_table}_range2.query_start 
and ${RMBLR_table}_range.query_end=${RMBLR_table}_range2.query_end 
and ${RMBLR_table}_range.subject_start=${RMBLR_table}_range2.subject_start 
and ${RMBLR_table}_range.subject_end = ${RMBLR_table}_range2.subject_end 
and ${RMBLR_table}_range.path>${RMBLR_table}_range2.path;

select count(*) from ${RMBLR_table}_doublons;
drop table if exists ${RMBLR_table}_nodoublons;
create table ${RMBLR_table}_nodoublons
select ${RMBLR_table}.*
from ${RMBLR_table} left join ${RMBLR_table}_doublons on ${RMBLR_table}_doublons.path_to_rm=${RMBLR_table}.path
where ${RMBLR_table}_doublons.path_to_rm is null ;

EOF
