#! /usr/bin/env python

import os
import sys

startupfilename = os.environ.get('PYTHONSTARTUP')
if startupfilename and os.path.isfile(startupfilename):
    execfile(startupfilename)

from pyRepet.sql.RepetDBMySQL import *
import pyRepet.sql.repetAligner
import getopt
#-----------------------------------------------------------------------------
def help():
        print "usage:",sys.argv[0]," [ options ]"
        print "option:"
        print "    -h: this help"
        print "    -m: match table"
        print "    -q: query sequence table"
        print "    -s: subject sequence table"
        print "    -Q: query contig map"
        print "    -S: subject contig map"
#-----------------------------------------------------------------------------
def main():

    match_table=""
    subject_table=""
    query_table=""
    scontig_map=""
    qcontig_map=""
    
    opts, args = getopt.getopt(sys.argv[1:],"hm:s:q:S:Q:")
    for o,a in opts:
        if o == "-h":
            help()
            return
        if o == "-m":
            match_table=a
        if o == "-s":
            subject_table=a
        if o == "-q":
            query_table=a
        if o == "-Q":
            qcontig_map=a
        if o == "-S":
            scontig_map=a
            
    if  match_table=="" or subject_table=="" or query_table=="":
        help()
        return
    if subject_table.split("_")[-1]!="seq" :
        print subject_table ,"wrong table type!!"
        return
    if query_table.split("_")[-1]!="seq" :
        print query_table ,"wrong table type!!"
        return
    db=RepetDB()
    pyRepet.sql.repetAligner.align_path_sequence(db,match_table,query_table,subject_table,qcontig_map,scontig_map)

    print "ALL ALIGNMENT DONE !!"
    
#----------------------------------------------------------------------------
if __name__ == '__main__':
    main()