#!/usr/bin/env python2

import os
startupfilename = os.environ.get('PYTHONSTARTUP')
if startupfilename and os.path.isfile(startupfilename):
    execfile(startupfilename)

import getopt
import sys
import string
import re
from pyRepet.coord.Set import *
from pyRepet.coord.Path import *
from pyRepet.sql.RepetDBMySQL import *

def help():
        print "usage:",sys.argv[0]," [ options ]"
        print "option:"
        print "    -h: this help"
        print "    -q: TE table"
        print "    -t: table type (set_range/path_range)"

def main ():
    
    TE_table=""
    type=""
    
    opts, args = getopt.getopt(sys.argv[1:],"hq:t:")
    if len(args) != 0:
        help()
        return 1
    for o,a in opts:
        if o == "-h":
            help()
        if o == "-q":
            TE_table=a
        if o == "-t":
            type=a

    if TE_table=="" or type=="":
        help()
        return 1
        
    db=RepetDB()

    sql_cmd="SELECT * FROM "+TE_table+" ;"
    db.execute(sql_cmd)
    query_matches=db.fetchall()

    fout=open(TE_table+".nest.map","w")

    if type=="set_range":
        m1=Set()
        m2=Set()
        for i in query_matches:
            m1.set_from_tuple(i)
            str_select='SELECT * FROM %s WHERE chr = "%s" AND (%d > LEAST(start,end) AND %d < GREATEST(start,end));'
            sql_cmd=str_select%(TE_table,m1.seqname,m1.getMin(),m1.getMax())
            db.execute(sql_cmd)
            result_TE=db.fetchall()
 
            if result_TE!=():
                print "***********"
                m1.show()
                print "in:"
                for j in result_TE:
                    m2.set_from_tuple(j)
                    m2.show()
                fout.write("%s\n"%(m1.toString()))

    if type=="path_range":
        m1=Path()
        m2=Path()
        for i in query_matches:
            m1.set_from_tuple(i)
            str_select='SELECT * FROM %s WHERE query_name = "%s" AND (%d > LEAST(query_start,query_end) AND %d < GREATEST(query_start,query_end));'
            sql_cmd=str_select%(TE_table,m1.range_query.seqname,\
                                m1.range_query.getMin(),m1.range_query.getMax())
            db.execute(sql_cmd)
            result_TE=db.fetchall()

 
            if result_TE!=():
                print "***********"
                m1.show()
                print "in:"
                for j in result_TE:
                    m2.set_from_tuple(j)
                    m2.show()
                fout.write("%s\n"%(m1.toString()))

    
if __name__ == "__main__": 
    main ()





