class GenomeBackbone( object ):
    
    def __init__(self):
        self._lTerminals = []
        self._index = 0
        
    def __eq__(self, o):
        return self._lTerminals == o._lTerminals
    
    def __str__(self):
        msg = ""
        for term in self._lTerminals:
            msg = msg + "%s" % term
        return msg
    
    def __iter__(self):
        return self
	
    def getIndex(self):
	return self._index	   
 
    def next(self):
        if self._index == self.getLength():
	    self._index = 0
            raise StopIteration
        else:
            next = self._lTerminals[self._index]
            self._index = self._index + 1
            return next
        
    def append(self, terminal):
        self._lTerminals.append(terminal)
        
    def count(self, termSymbol):
        return self._lTerminals.count(termSymbol)
    
    def getPcent(self, termSymbol):
        if self.getLength() == 0:
            return 0
        return ( float(self._lTerminals.count(termSymbol)) / float(self.getLength()) ) * 100
    
    
    def getPcentTe(self, lTransitionProba):
        return self.getPcent("t")
            
    def getLength(self):
        return len(self._lTerminals)
    
    def getStats(self):
        msg = "length:%i" % ( self.getLength() )
        lSymbols = list( set( self._lTerminals ) )
        lSymbols.sort()
        for s in lSymbols:
            msg += " %s:%.2f%% (%i)" % ( s, self.getPcent(s), self.count(s) )
        return msg

    def getSymbolPosition(self, symbolToFind):
        lPosition = []
        index = 0
        for symbol in self._lTerminals:
            if symbolToFind == symbol:
                lPosition.append(index)
            index = index + 1
        return lPosition
