#!/usr/bin/env python

import os
startupfilename = os.environ.get('PYTHONSTARTUP')
if startupfilename and os.path.isfile(startupfilename):
    execfile(startupfilename)

import sys
from commons.core.sql.DbFactory import DbFactory
from commons.core.coord.Align import Align
from commons.core.coord.Range import Range

def help ():
    print "usage:",sys.argv[0]," [blast out table] "
         
def main ():
    if len(sys.argv) < 2 :
        help()
        return   
    else:
        table=sys.argv[1]


        #######################
        # DATABASE CONNECTION #
        #######################
        repet = DbFactory.createInstance()


        ##############################
        #    Convert Table to List   #
        ##############################
        repet.execute('SELECT * FROM %s' % table)
        result=repet.fetchall()
        new_result=[]
        for I in result :
            new_result.append(I)

        file_out_init=open(str(table)+"_Palin","w")


        ########################
        #    Update the List   #
        ########################
        for i in range(len(new_result)):
            a=Align()
            
            # Be careful !!! : Don't use set_from_tuple() function if you want keep the real orientation
            a.range_query=Range(new_result[i][0],new_result[i][1],new_result[i][2])
            a.range_subject=Range(new_result[i][3],new_result[i][4],new_result[i][5])
            a.e_value=float(new_result[i][6])
            a.score=float(new_result[i][7])
            a.identity=float(new_result[i][8])

            Qname=a.range_query.seqname
            Qstart=a.range_query.start
            Qend=a.range_query.end
            Sstart=a.range_subject.start
            Send=a.range_subject.end
            
            #Detect palindromics matchs
            select_palin='select query_name from %s where query_name=subject_name and "%s"=query_name and\
            %d=query_start and %d=query_end and query_start=subject_end and query_end=subject_start limit 1;' 
            sql_palin=select_palin%(table,Qname,Qstart,Qend)
            
#            print "**********************"
#            print "Align:"
#            print a.toString()
#            print "**********************"
#            
#            print "**********************"
#            print "sql_palin"
#            print sql_palin
#            print "**********************"
            
            repet.execute(sql_palin)
            result_palin=repet.fetchall()
            
#            print "**********************"
#            print "result palin"
#            print result_palin
#            print "**********************"
           
            if result_palin==():
#                print "======================> no doublons"
                if Qstart < Qend and Sstart > Send and Qstart > Sstart:
#                    print "======================> condition bizarre"
                    #Dectect cross matchs in match file
                    select_cross='select * from %s where query_name=subject_name and "%s"=query_name and\
                    %d=subject_end and %d=subject_start and %d=query_end and %d=query_start limit 1;'    
                    sql_cross=select_cross%(table,Qname,Qstart,Qend,Sstart,Send)
#                    
#                    print "**********************"
#                    print "sql_cross"
#                    print sql_cross
#                    print "**********************"
                    
                    repet.execute(sql_cross)
                    result_cross=repet.fetchall()
                    
                    if result_cross==():
                        a.write(file_out_init)
                    else:
                        a.show()
                        print "CROSS:",result_cross
                    
                else:
#                    print "======================> writing align to file"
                    a.write(file_out_init)
           
        file_out_init.close()       
        
if __name__ == "__main__": 
    main ()

  
