#!/usr/bin/env python2

import os
startupfilename = os.environ.get('PYTHONSTARTUP')
if startupfilename and os.path.isfile(startupfilename):
    execfile(startupfilename)

import getopt
import sys
import string
import re
from pyRepet.sql.RepetDBMySQL import *
from pyRepet.sql.TableAdaptator import *
import pyRepet.coord.Map
import pyRepet.coord.Path
import pyRepet.coord.Set

def help():
        print "usage:",sys.argv[0]," [ options ]"
        print "option:"
        print "    -h: this help"
        print "    -q: table"
        print "    -s: simple repeats table"
        print "    -r: remaining size (default=170)"
        print "    -t: table types ([path,set]/[path,set])"

def main ():
    
    qtable=""
    stable=""
    qtype=""
    stype=""
    remain_thres_size=170
    
    opts, args = getopt.getopt(sys.argv[1:],"hq:s:t:r:")
    if len(args) != 0:
        help()
        return 1
    for o,a in opts:
        if o == "-h":
            help()
        if o == "-q":
            qtable=a
        if o == "-s":
            stable=a
        if o == "-t":
            qtype=a.split("/")[0]
            stype=a.split("/")[1]
        if o == "-r":
            remain_thres_size=int(a)

    if qtable=="" or stable=="" or qtype=="" or stype=="":
        help()
        return
    
    db=RepetDB()

    if qtype=="path":
        qtablePathAdaptator=TablePathAdaptator(db,qtable)
        path_num_list=qtablePathAdaptator.getPath_num()
    elif qtype=="set":
        qtableSetAdaptator=TableSetAdaptator(db,qtable)
        path_num_list=qtableSetAdaptator.getPath_num()
    else:
        print "Unknown query table type:",qtype

    
    if stype=="path":
        stablePathAdaptator=TablePathAdaptator(db,stable)
    elif stype=="set":
        stableSetAdaptator=TableSetAdaptator(db,stable)
    else:
        print "Unknown subject table type:",stype

    path2remove=[]
    count=0
    for path_num in path_num_list:
        if qtype=="path":
            qlist=qtablePathAdaptator.getPathList_from_num(path_num)
            qlist=pyRepet.coord.Path.path_list_rangeQ2Set(qlist)
        elif qtype=="set":
            qlist=qtableSetAdaptator.getSetList_from_num(path_num)

        qlist.sort()
        qmin,qmax=pyRepet.coord.Set.set_list_boundaries(qlist)

        qmin=qmin-1
        qmax=qmax+1
        if stype=="path":
            slist=stablePathAdaptator.getPathList_from_qcoord(qlist[0].seqname.split()[0],qmin,qmax)
            slist=pyRepet.coord.Path.path_list_rangeQ2Set(slist)
        elif stype=="set":
            slist=stableSetAdaptator.getSetList_from_qcoord(qlist[0].seqname.split()[0],qmin,qmax)

        if len(slist)>0:
            print "----------------------------------------"
            print "annot:"
            pyRepet.coord.Set.set_list_show(qlist)
            qlist=pyRepet.coord.Set.set_list_merge(qlist)
            qsize=pyRepet.coord.Set.set_list_size(qlist)
            print "annot size=",qsize
            
            print "simple repeats list:"
            pyRepet.coord.Set.set_list_show(slist)
            slist=pyRepet.coord.Set.set_list_merge(slist)
            ssize=pyRepet.coord.Set.set_list_size(slist)
            osize=pyRepet.coord.Set.set_list_overlap_size(qlist,slist)

            print "merged simple repeats list:"
            pyRepet.coord.Set.set_list_show(slist)
            print "simple repeats size=",ssize
            print "overlap size=",osize,"--> remains=",qsize-osize
                
            if qsize-osize<remain_thres_size:
                print "remove path %d"%(qlist[0].id)
                path2remove.append(qlist[0].id)
                count=count+1

    print "Number of path to remove:",count
    path2remove.sort()

    fout=open(qtable+".noSSR","w")
    for p in path2remove:
        fout.write("%d\n"%p)
    
if __name__ == "__main__": 
    main ()

