#!/usr/bin/env python


#startupfilename = os.environ.get('PYTHONSTARTUP')
#if startupfilename and os.path.isfile(startupfilename):
#   execfile(startupfilename)
    
import user
import os
import sys
import getopt
import MySQLdb
import ConfigParser
from commons.core.sql.DbMySql import DbMySql

#-----------------------------------------------------------------------------

def help ():
    print "usage:",sys.argv[0]," [ options ]"
    print "option:"
    print "    -m: the map table name"
    print "    -h: this help"
    print "    -c: configuration file from the SATannot pipeline"
    print "    -v: verbose (default=0)"
    print

#-----------------------------------------------------------------------------

def uniqlist( list, i ):

    if list.count( i )== 1:
        list.remove( i )
    list.append( i )
    return list

#-----------------------------------------------------------------------------

def main ():

    """
    This program returns a map file with selected pyramids using a MySQL table.
    """

    inMapTable = ""
    verbose = 0

    try:
        opts,args = getopt.getopt(sys.argv[1:],"hm:c:v:") 
    except getopt.GetoptError, err:
        print str(err); help(); sys.exit(1)

    for o,a in opts:
        if o == "-h":
            help(); sys.exit(0)
        elif o == "-m":
            inMapTable = a
        elif o == "-c":
            configFileName = a
        elif o == "-v":
            verbose = int(a)
            
    if inMapTable == "":
        print "*** Error: missing compulsory options -m "
        help()
        sys.exit(1)
        
    if verbose > 0:
        print "beginning of %s" % ( sys.argv[0].split("/")[-1] )
        sys.stdout.flush()
  
    if configFileName != "":
        if not os.path.exists( configFileName ):
            print "*** Error: configuration file '%s' doesn't exist" % ( configFileName )
            sys.exit(1)
        config = ConfigParser.ConfigParser()
        config.readfp( open(configFileName) )
        host = config.get( "repet_env","repet_host" )
        user = config.get( "repet_env","repet_user" )
        passwd = config.get( "repet_env","repet_pw" )
        dbname = config.get( "repet_env","repet_db" )
   
    #Databases Connection#-----------------------------------------------------------------------------

    db = DbMySql( user, host, passwd, dbname )

    selectedPyramidTable = inMapTable + "_clean"
    db.dropTable(selectedPyramidTable)
    db.execute('create table %s like %s ;' % ( selectedPyramidTable, inMapTable ))
    
    #Create cluster list (Pile list)#-----------------------------------------------------------------------------
   
    sql_cmd = 'select name from %s;' % ( inMapTable )
    db.execute( sql_cmd )
    inMapTableResult = db.fetchall()

    #cluster_list = []
    cluster_dico = {}
    
    cluster = int( inMapTableResult[0][0].split("Cl")[1] )
    cluster_dico[cluster] = cluster
    #cluster_list.append( cluster )
    # check this loop ????
    for motifName in inMapTableResult:
        cluster = int( motifName[0].split("Cl")[1] )
        if not cluster_dico.has_key( cluster ):
            cluster_dico[ cluster ] = cluster
            #cluster_list.append( cluster )
    # PILER terminology one cluster == one Cluster (Cl)
    for cluster in cluster_dico.keys():
        #ref_chromosome = Map()
        #chromosome = Map()
    
        select_cmd ='select * from %s where name like "%%Cl%d";'
        db.execute(select_cmd %(inMapTable, cluster))
        motifList = db.fetchall()
        #print(motifList)
        
        group_dico = {}
        result = []
        c = 0
        # motif = group = pyramid
        for motif in motifList :
            # pyramid name = number of group
            pyramidName = int(motif[0].split("Gr")[1].split("Cl")[0])
            pyramidChr = motif[1]	
            pyramidSize = abs(int(motif[3])-int(motif[2]))
            db.execute('select count(*) from %s where name like "%%Gr%dCl%%";'%( inMapTable, pyramidName ))
            # Nb member in a group
            pyramidCopyNb = int(db.fetchall()[0][0])
            # PILER terminology one pyramid == one Group (Gr)
            group_dico[pyramidName ] = (pyramidCopyNb, pyramidSize, pyramidName )

        info_pyramid = group_dico.values()
        info_pyramid.sort()
        # keep the pyramid containing maximum members
        selection = info_pyramid[len( info_pyramid )-1]
    
        if len( info_pyramid )>1: 
            print "Cluster -> " + str( cluster ) + "\tNumber of group -> " + str( len( info_pyramid ) )
            print "Select group #" + str( selection[2] ) + " with " + str( selection[0] ) + " units of " + str( selection[1] ) + "bp"
            print "-"*50

        db.execute('insert into %s select * from %s where name like "%%Gr%dCl%%" ;'%( selectedPyramidTable, inMapTable,  selection[2] ))
 
        # Convert table 2 file 
        os.system(('mysql %s -h %s -P 3306 -u %s -p%s -e " select * from %s ;" > %s.txt')%(dbname, host, user, passwd, selectedPyramidTable,  selectedPyramidTable))

    db.close()
    if verbose > 0:
        print "%s finished successfully" % ( sys.argv[0].split("/")[-1] )
        sys.stdout.flush()

    return 0

#-----------------------------------------------------------------------------

if __name__ == "__main__" :
    main ()
