#!/usr/bin/env python

import os
import sys
import getopt
import exceptions

if not os.environ.has_key( "REPET_PATH" ):
    print "ERROR: no environment variable REPET_PATH"
    sys.exit(1)
sys.path.append( os.environ["REPET_PATH"] )
from pyRepet.parser.Parser import Parser


def help():
    print
    print "usage:",sys.argv[0]," [ options ]"
    print "options:"
    print "     -h: this help"
    print "     -i: input file name (GFF format, output from Pals)"
    print "     -a: same sequences (~ all-by-all)"
    print "     -o: output file name (align format, default=inFileName+'.align')"
    print


def main():

    inFileName = ""
    sameSequences = False
    outFileName = ""

    try:
        opts, args = getopt.getopt(sys.argv[1:],"hi:ao:")
    except getopt.GetoptError:
        help()
        sys.exit(1)
    for o,a in opts:
        if o == "-h":
            help()
            sys.exit(0)
        elif o == "-i":
            inFileName = a
        elif o == "-a":
            sameSequences = True
        elif o == "-o":
            outFileName = a
            
    if inFileName == "":
        print "ERROR: missing input file name"
        help()
        sys.exit(1)

    if outFileName == "":
        outFileName = inFileName + ".align"

    parser = Parser( inFileName, outFileName )
    parser.pals2align( sameSequences )

    return 0


if __name__ == "__main__":
    main()
