#!/usr/bin/env python

import os, sys

from pyRepet.seq.Bioseq import *
from AlignedBioseqDBfab_tim import *

class ReadClustal:
    def __init__(self,file):
        self.file=file
        self.clustalfile=None
        self.nbreseq=None
        self.ecart=None
        self.line=None
        self.dico=None
    
    def subseq(self):# extraction de la seq d'une ligne
        sub_line=self.line.split(" ",1)[1]
        comp=0
        i=0
        while sub_line[i]==" ":
            comp+=1
            i+=1
            
        end=len(sub_line)-1
        subseq=sub_line[comp:end]
    
        return subseq

    def buildAlbDB(self):
        self.readClustal()
        print 'nbreseq',self.nbreseq,'ecart',self.ecart
        self.nbrdesaut=self.ecart+1
        stop,first=1,1
        while stop :
            for nb in range(self.nbreseq):
                if first:
                    try:
                        name=self.line.split(" ",1)[0]
                        self.dico[name]=self.dico[name]+self.subseq()
                        first=0
                    except KeyError:
                        stop=0
                else:
                    self.line=self.clustalfile.readline()
                    name=self.line.split(" ",1)[0]
                    self.dico[name]=self.dico[name]+self.subseq()
            for nb in range(self.nbrdesaut):
                self.line=self.clustalfile.readline()
                first=1
                
        AlDB=AlignedBioseqDB()
        for key in self.dico:
            print key,' length: ',len(self.dico[key])
            bs=Bioseq()
            bs.header=key
            bs.sequence=self.dico[key]
            AlDB.add(bs)
        return AlDB
        
    def readClustal(self):
        self.clustalfile=open(self.file,'r')
        test=open(self.file,'r')
            
        self.line=self.clustalfile.readline()
        firstword=self.line.split(" ",1)[0]
        if firstword!='CLUSTAL':
            print "this file isn't a clustal file"
            sys.exit(0)
        
        first,stop,self.ecart=1,1,0
        while stop or first:
            if first:
                self.line=self.clustalfile.readline()
                first=0
            try:
                self.line.split(" ",1)[1]
                stop=0
            except IndexError:
                self.line=self.clustalfile.readline()
                self.ecart+=1 # nre de ligne faire pour aller d un bloc de seq a l autre
    ## print 'r',line,'line',len(line),lineNB
    
        for i in range(self.ecart+2):# pour se positionner sur la 1ere seq dans objet file test
            Test=test.readline()
        self.dico={}
        stop,self.nbreseq=1,0
        while stop:
            try:
                Test.split(" ",1)[1]
                self.dico[Test.split(" ",1)[0]]=""
                Test=test.readline()
                self.nbreseq+=1
            except IndexError:
                if "" in self.dico:
                    del self.dico[""]
                stop=0
                self.nbreseq-=1
