import sys

from pyRepet.coord.Range import *
from pyRepet.seq.Bioseq import *

#------------------------------------------------------------------------------

class ExtractFasta:

    #--------------------------------------------------------------------------

    def __init__( self, sign_of_nod_ref ):

        self.nod_ref = sign_of_nod_ref
    
    #--------------------------------------------------------------------------

    # Record for each sequence in lNameSeq the range of its matchs

    def dico_seq( self, lNameSeq, listPath ):

        dSeqRange = {}
        for seq in lNameSeq:
            dSeqRange[seq] = []

        for path in listPath:
            qn = path.range_query.seqname
            sn = path.range_subject.seqname

            if qn in dSeqRange:
                dSeqRange[qn].append( [path.range_query,1] )
            else:
                print "*** Error: ExtractFasta.py -> dico_seq -> pbm 1 ***"
                sys.exit(0)

            if sn in dSeqRange:
                dSeqRange[sn].append( [path.range_subject,1] )
            else:
                print "*** Error: ExtractFasta.py -> dico_seq -> pbm 2 ***"
                sys.exit(0)

        return dSeqRange

    #--------------------------------------------------------------------------

    def overlap_killer( self, dSeqRange ):

        # for each sequence
        for seqName in dSeqRange:

            # record its number of matching fragments
            nbFragmt = len(dSeqRange[seqName])
##             for i in range(nbFragmt):
##                 if not dSeqRange[seqName][i][0].isPlusStrand():
##                     dSeqRange[seqName][i][0].reverse()

            # for each of its fragments
            for i in range(nbFragmt):
                if dSeqRange[seqName][i][0].getStrand() != \
                       self.nod_ref[dSeqRange[seqName][i][0].seqname]:
                    dSeqRange[seqName][i][0].reverse()

            for i in range(nbFragmt-1):
                if dSeqRange[seqName][i][1] == 1: 
                    idem = 1
                    while idem:
                        idem = 0
                        startmin, endmax = [], []
                        for j in range((i+1),nbFragmt):
                            if dSeqRange[seqName][j][1] == 1 and dSeqRange[seqName][i][0].overlap(dSeqRange[seqName][j][0]):
                                startmin.append(dSeqRange[seqName][i][0].start)
                                startmin.append(dSeqRange[seqName][j][0].start)
                                endmax.append(dSeqRange[seqName][i][0].end)
                                endmax.append(dSeqRange[seqName][j][0].end)
                                dSeqRange[seqName][j][1] = 0
                                idem = 1
                        if startmin != [] and endmax != []:
                            if self.nod_ref[dSeqRange[seqName][i][0].seqname]=='+':
                                dSeqRange[seqName][i][0].start = min(startmin)
                                dSeqRange[seqName][i][0].end = max(endmax)
                            elif self.nod_ref[dSeqRange[seqName][i][0].seqname]=='-':
                                dSeqRange[seqName][i][0].start = max(startmin)
                                dSeqRange[seqName][i][0].end = min(endmax)

            test = []
            for i in range(nbFragmt):
                test.append([dSeqRange[seqName][i][0].start,dSeqRange[seqName][i]])
            test.sort()
##             dSeqRange[seqName]=[]
##             dSeqRange[seqName]=[i[1] for i in test]
##             print 'dSeqRange['+seqName+']',dSeqRange[seqName]

            dSeqRange[seqName] = []
            for i in test:
                if i[1][1] == 1:
                    dSeqRange[seqName].append( i[1] )
           # print 'dSeqRange2['+seqName+']',dSeqRange[seqName][0][0].start,dSeqRange[seqName][0][0].end
           ##  for i in dSeqRange[seqName]:
##                 print 'start',i[0].start,'end',i[0].end
##             print 'nombre',len(dSeqRange[seqName])

        return dSeqRange

    #--------------------------------------------------------------------------

    def build_fasta( self, dSeqRange, inFastaFileName ):

        bs = Bioseq()
        inFastaFile = open( inFastaFileName, "r" )
        outFile = open( inFastaFileName+".filtered", "w" )

        # parse the input fasta file
        while 1:
            bs.read( inFastaFile )

            if bs.header == None or bs.sequence == None :
                break

            # if the sequence belongs to dSeqRange
            if bs.header in dSeqRange:
                tempglobalsub = Bioseq()
                tempsub = None
                subseq = ""
                nbFragmt = len(dSeqRange[bs.header])
##                 print "bs.header",bs.header
##                 print "nbFragmt",nbFragmt

                # for each of its matching fragments
                for i in range(nbFragmt):
                    if dSeqRange[bs.header][i][1] == 1:
                        if dSeqRange[bs.header][i][0].getStrand() != \
                               self.nod_ref[bs.header]:
                            print "*** Error: ExtractFasta.py ",\
                                  "-> buildFasta() ***"
                            sys.exit(0)

                # for each of its matching fragments
                for i in range(nbFragmt):
                    complementary = 0
                    if dSeqRange[bs.header][i][1] == 1:  #~~1
                        if self.nod_ref[bs.header] == "-":
                            dSeqRange[bs.header][i][0].reverse()
                            complementary = 1
                        tempsub = bs.subseq(dSeqRange[bs.header][i][0].start,dSeqRange[bs.header][i][0].end)
                        if complementary:
                            tempsub.sequence = tempsub.complement()
                        subseq = subseq + tempsub.sequence

                tempglobalsub.header = bs.header
                tempglobalsub.sequence = subseq
                tempglobalsub.write( outFile )

    #--------------------------------------------------------------------------

    def buildGappedFasta(self,dSeqRange,fasta,name_length):

        bs=Bioseq()
        gfile=open(fasta+".filtered.gapped","w")
        fastafile=open(fasta,"r")
        while 1:
            bs.read(fastafile)
            if bs.header==None or bs.sequence==None :
                break
            if bs.header in dSeqRange:
                tempglobalsub=Bioseq()
                tempsub=None
                subseq=""
                temp_end=None
                nbFragmt=len(dSeqRange[bs.header])
                #print "nbFragmt",nbFragmt,"header",bs.header,"longueur",name_length[bs.header]
                complementary=0
                if self.nod_ref[bs.header]=="-":
                    for i in range(nbFragmt):
                        dSeqRange[bs.header][i][0].reverse()
                    complementary=1
                for i in range(nbFragmt):
##                     complementary=0
##                     if self.nod_ref[bs.header]=="-":
##                         dSeqRange[bs.header][i][0].reverse()
##                         complementary=1
                    if i==0:
                        if nbFragmt>=1:
                            if dSeqRange[bs.header][i][0].start>1:
                                #print dSeqRange[bs.header][i][0].start,dSeqRange[bs.header][i][0].end,dSeqRange[bs.header][i][0].seqname
                                tempsub=bs.subseq(dSeqRange[bs.header][i][0].start,dSeqRange[bs.header][i][0].end)
                                if complementary:
                                    tempsub.sequence=tempsub.complement()                                    
                                j=1
                                while j<dSeqRange[bs.header][i][0].start:
                                    subseq=subseq+"-"
                                    j+=1
                                subseq=subseq+tempsub.sequence
                            elif dSeqRange[bs.header][i][0].start==1:
                                tempsub=bs.subseq(dSeqRange[bs.header][i][0].start,dSeqRange[bs.header][i][0].end)
                                if complementary:
                                    tempsub.sequence=tempsub.complement()                                    
                                subseq=subseq+tempsub.sequence
                            if nbFragmt==1:
                                if dSeqRange[bs.header][i][0].end<name_length[bs.header]:
                                    j=dSeqRange[bs.header][i][0].end+1
                                    while j<=name_length[bs.header]:
                                        subseq=subseq+"-"
                                        j+=1
                                    
                    elif i<=(nbFragmt-1) and nbFragmt>1:
                        if (dSeqRange[bs.header][i-1][0].end+1)<=dSeqRange[bs.header][i][0].start:
                            if (dSeqRange[bs.header][i-1][0].end+1)<dSeqRange[bs.header][i][0].start:
                                j=dSeqRange[bs.header][i-1][0].end+1
                                while j<dSeqRange[bs.header][i][0].start:
                                    subseq=subseq+"-"
                                    j+=1
                            tempsub=bs.subseq(dSeqRange[bs.header][i][0].start,dSeqRange[bs.header][i][0].end)
                            if complementary:
                                tempsub.sequence=tempsub.complement()                                    
                            subseq=subseq+tempsub.sequence
                        elif (dSeqRange[bs.header][i-1][0].end)>=dSeqRange[bs.header][i][0].start:
                            print "Error of overlaping in Extract_fasta.py"
                            print bs.header
                            sys.exit(0)
                        if i==(nbFragmt-1):
                            if dSeqRange[bs.header][i][0].end<name_length[bs.header]:
                                j=dSeqRange[bs.header][i][0].end+1
                                while j<=name_length[bs.header]:
                                    subseq=subseq+"-"
                                    j+=1
                            elif dSeqRange[bs.header][i][0].end==name_length[bs.header]:
                                pass
                            elif dSeqRange[bs.header][i][0].end>name_length[bs.header]:
                                print "Error of editing in Extract_fasta.py or before"
                                sys.exit(0)
                
                tempglobalsub.header=bs.header
                tempglobalsub.sequence=subseq
                tempglobalsub.write(gfile)
