#!/usr/bin/env python

import os,sys,copy
#import biggles

from pyRepet.seq.Bioseq import *

#------------------------------------------------------------------------------

class PlotGraph:

    global color
    color=['PaleTurquoise','RoyalBlue1','DarkSeaGreen1','green1','gold4','IndianRed1','chocolate1','orange1','VioletRed2','DarkRed']

    #--------------------------------------------------------------------------

    def __init__( self, inFastaFileName="" ):

        self.file = inFastaFileName
        if inFastaFileName:
            self.to_log = inFastaFileName+"-"+str(os.getpid())+"-.log"
            self.log = open( self.to_log, "a+" )
            self.log.seek(0)
            self.dico = {}
            while 1:
                line = self.log.readline()
                if not line or line == "\n":
                    break
                self.dico[line.split("\t")[1]] = line.split("\t")[0]
            self.catch_seqs = open( "seqs_oriented.log", "w" )
        else:
            self.to_log = ""

    #--------------------------------------------------------------------------

    def getNameAndLength( self, inFastaFileName ):

        bs = Bioseq()
        inFastaFile = open( inFastaFileName, "r" )
        dSeqNameLength = {}

        while 1:
            bs.read( inFastaFile )
            if bs.header == None or bs.sequence == None:
                break
            dSeqNameLength[bs.header] = len( bs.sequence )

        return dSeqNameLength

    #--------------------------------------------------------------------------

    # return the order of each sequence compare to the others

    def orderForDraw( self, lNameSeq ):

        dNameOrder = {}

        for i in range(len(lNameSeq)):
            dNameOrder[lNameSeq[i]] = i

        return dNameOrder

    #--------------------------------------------------------------------------

    def Y_ForDraw( self, seqName, dNameOrder ):

        for k in dNameOrder:
            if seqName == k:
                return dNameOrder[k]

    #--------------------------------------------------------------------------

    def color_identity( self, identity, current_path=None ):

        ident = identity[0] - identity[1]   # max - min
        section = ident / 10.0
        test = float(current_path.identity)
        i = 0
        if test == identity[1]:   # if test = min
            i = 0
        else:
            while (not(test>(identity[1]+(section*i))))or (not(test<=(identity[1]+section*(i+1)))):
                i += 1

        return color[i]

    #--------------------------------------------------------------------------

    def matrix_reloaded( self, lNodes ):

        crespo = []
        riquelme = []
        dico_sign_ref_nod = {}
        p_trunk = lNodes[0]
        stop = 1

        print "\n* sign of ref nod:"

        if self.to_log:
            output = "\n" + "------sign of ref nod----" + "\n"
            self.log.write( output )

        while stop:
            branch = p_trunk
            print branch.NameSeq, branch.strand
            if self.to_log:
                output = str(branch.NameSeq)+"\t"+str(branch.strand)+"\n"
                self.log.write(output)
                output = self.dico[branch.NameSeq]+"\t"+str(branch.strand)+"\n"
                self.catch_seqs.write(output)
            dico_sign_ref_nod[branch.NameSeq] = branch.strand
            while branch.right != None:
                branch = branch.right
                for i in branch.NP:
                    if i not in riquelme:
                        riquelme.append(i)
                        crespo.append((i.score*-1,i))
            if p_trunk.up == []:
                stop = 0
            else:
                p_trunk = p_trunk.up[0]

        crespo.sort()
        riquelme = []

        print

        for i in crespo:
            riquelme.append(i[1])
            print 'HSP '+str(crespo.index(i))+' -->',i[1].id,i[1].score,i[1].range_query.seqname.split(" ",1)[0],i[1].range_subject.seqname.split(" ",1)[0]
            if self.to_log:
                if crespo.index(i)==0:
                    self.log.write('\n')
                output='HSP '+str(crespo.index(i))+' -->'+str(i[1].id)+' '+str(i[1].score)+' ' \
                        +str(i[1].range_query.seqname.split(" ",1)[0])+' '+str(i[1].range_subject.seqname.split(" ",1)[0])+'\n'
                self.log.write(output)

        print "\nnb of HSPs to display: " + str(len(riquelme))

        if self.to_log:
            output='nb of paths to display '+str(len(riquelme))+'\n'+'\n'
            self.log.write(output)
            self.log.close()
            self.catch_seqs.close()

        print

        return riquelme, dico_sign_ref_nod
    
    #--------------------------------------------------------------------------

    def searchMaxAndMinIdentity( self, lOrdPath ):

        Max_identity = 0
        Min_identity = 100
        Max_and_Min = []

        for path in lOrdPath:
            if Max_identity < path.identity:
                Max_identity = path.identity
            if Min_identity > path.identity:
                Min_identity = path.identity

        Max_and_Min.append( Max_identity )
        Max_and_Min.append( Min_identity )

        return Max_and_Min

    #--------------------------------------------------------------------------

    def preparePlotFile( self, lNameSeq, dSeqNames, dSeqNameLength, pathFileName, lPaths, step ):

        plotSeqFile = open( self.file + "_plotSeq.txt", "w" )
        plotSeqFile.write( "order\tname\tlength\n" )
        count = 0
        for newSeqName in lNameSeq:
            count += 1
            plotSeqFile.write( str(count) + "\t" + dSeqNames[newSeqName] + "\t" +
                               str(dSeqNameLength[newSeqName]) + "\n" )
        plotSeqFile.close()

        plotHSPFile = open( self.file + "_plotHSP_" + step + ".txt", "w" )
        plotHSPFile.write( "qname\tqstart\tqend\tsname\tsstart\tsend\tid\n" )

        if step == "befFltr":
            pathFile = open( pathFileName, "r" )
            line = pathFile.readline()
            while 1:
                if line == "" or line == None:
                    break
                else:
                    line = line.split("\t")
                    if line[1] != line[4]:
                        plotHSPFile.write( dSeqNames[line[1]] + "\t" + line[2] +\
                                           "\t" + line[3] + "\t" + \
                                           dSeqNames[line[4]] + "\t" + line[5] +\
                                           "\t" + line[6] + "\t" + line[9] )
                line = pathFile.readline()
            pathFile.close()

        elif step == "aftFltr":
            for path in lPaths:
                plotHSPFile.write( dSeqNames[str(path.range_query.seqname)] +\
                                   "\t" + str(path.range_query.start) + "\t" +\
                                   str(path.range_query.end) + "\t" +\
                                   dSeqNames[str(path.range_subject.seqname)] +\
                                   "\t" + str(path.range_subject.start) + "\t" +\
                                   str(path.range_subject.end) + "\t" +\
                                   str(path.identity) + "\n" )

        plotHSPFile.close()

    #--------------------------------------------------------------------------

    def adaptRFile( self, RFileName, step ):

        cmd = "Seq = data.frame( read.table( '" + self.file + "_plotSeq.txt', header=T ) )\n"
        cmd += "HSP = data.frame( read.table( '" + self.file + "_plotHSP_" + step + ".txt', header=T ) )\n"
        cmd += "attach(Seq)\n"
        cmd += "attach(HSP)\n"
        cmd += "my_xlim = c( -0.5 * max(Seq$length), max(Seq$length) )\n"
        cmd += "interseq = 1\n"
        cmd += "my_ylim = c( 1, length(Seq$name) + 1 )\n"
        cmd += "id_count = ( max(HSP$id) - min(HSP$id) ) / 6\n"
        cmd += "my_colors = c('#800080','#0000FF','#00FF00','#FF8040','#FF00FF','#FF0000')\n"
        cmd += "postscript( '" + self.file + "_" + step + ".eps' )\n"
        cmd += "i=1\n"
        cmd += "plot( seq(1,Seq$length[i]), rep(interseq*i,Seq$length[i]), type='l', lwd=2, xlim=my_xlim, ylim=my_ylim, main='visualize " + self.file + " (" + step + ")', xlab='coordinates', ylab='sequences' )\n"
        cmd += "text( -max(Seq$length)*0.25, interseq*i, Seq$name[i] )\n"
        cmd += "for (i in seq(2,length(Seq$name))) {\n"
        cmd += "segments( 1, interseq*i, Seq$length[i], interseq*i, lwd=2 )\n"
        cmd += "text( -max(Seq$length)*0.25, interseq*i, Seq$name[i] ) }\n"
        cmd += "for (j in seq(1,length(HSP[,2]))) {\n"
        cmd += "qorder = interseq * Seq$order[Seq$name==paste(HSP$qname[j])]\n"
        cmd += "sorder = interseq * Seq$order[Seq$name==paste(HSP$sname[j])]\n"
        cmd += "hsp_col = 1\n"
        cmd += "if (HSP$id[j] == min(HSP$id)) {\n"
        cmd += "hsp_col = 1 }\n"
        cmd += "else {\n"
        cmd += "while (HSP$id[j] > min(HSP$id) + hsp_col * id_count) {\n"
        cmd += "hsp_col = hsp_col + 1 } }\n"
        cmd += "segments( HSP$qstart[j], qorder, HSP$sstart[j], sorder, col=my_colors[hsp_col] )\n"
        cmd += "segments( HSP$qend[j], qorder, HSP$send[j], sorder, col=my_colors[hsp_col] ) }\n"
        cmd += "my_legend = signif( seq( min(HSP$id), max(HSP$id)-id_count, id_count ), digits=4 )\n"
        cmd += "legend( my_xlim[1], my_ylim[2], legend=my_legend, col=my_colors, pch='l', horiz=T)\n"
        cmd += "dev.off()\n"

        RFile = open( RFileName, "w" )
        RFile.write( cmd )
        RFile.close()

    #--------------------------------------------------------------------------

    def drawPlot( self, step ):

        RFileName = self.file + "_" + step + ".R"
        self.adaptRFile( RFileName, step )

        cmd = "R --slave --no-save < " + RFileName
        log = os.system( cmd )
        if log != 0:
            print "*** Error: R returned " + str(log)
            sys.exit(1)

    #--------------------------------------------------------------------------

    def draw( self, dSeqNameLength, lOrdPath, lNameSeq, title,\
              max_and_min_identity ):

        print "draw graph with biggles (if available)"

##         f = biggles.FramedPlot()

##         f.xlabel = "$Coord$"
##         f.x.ticklabels_style["fontsize"] = 0.5
##         f.x.ticklabels_style["textangle"] = 0

##         position = 0
##         for seq in lNameSeq:
##             if dSeqNameLength.has_key(seq):
##                 seg = biggles.Curve( [0,dSeqNameLength[seq]],\
##                                      [position,position] )
##                 f.add(seg)
##             else:
##                 print "Error in def draw"
##                 sys.exit(0)
##             position += 1

##         dNameOrder = self.orderForDraw( lNameSeq )

##         for path in lOrdPath:

##             if path.range_query.seqname != path.range_subject.seqname :

##                 YQ = self.Y_ForDraw( path.range_query.seqname, dNameOrder )
##                 YS = self.Y_ForDraw( path.range_subject.seqname, dNameOrder )

##                 seg = biggles.Curve( [path.range_query.start,path.range_query.end], [YQ,YQ], linewidth=5, linetype="solid" )
##                 f.add(seg)
##                 seg = biggles.Curve( [path.range_subject.start,path.range_subject.end], [YS,YS], linewidth=5, linetype="solid" )
##                 f.add(seg)

##                 seg = biggles.Curve( [path.range_query.start,path.range_subject.start], [YQ,YS], color=self.color_identity(max_and_min_identity,path) )
##                 f.add(seg)
##                 seg = biggles.Curve( [path.range_query.end,path.range_subject.end], [YQ,YS], color=self.color_identity(max_and_min_identity,path) )
##                 f.add(seg)

##         ylabel = []
##         for seq in lNameSeq:
##             a = seq.split(" ",1)
##             ylabel.append(a[0])

##         f.y1.ticklabels = ylabel
##         f.y1.ticklabels_style["fontsize"] = 0.8
##         f.y1.draw_ticks = 0
##         f.y2.draw_ticks = 0
##         f.y1.ticks = range(len(lNameSeq)+1)
##         if title[0] not in ['global','filtered']:
##             f.title = title[0]
##         else:
##             f.title = title[0]+' path'
##         f.aspect_ratio = 1/1

##         scale = biggles.FramedPlot()
##         scale.xlabel = ""
##         scale.ylabel = ""
##         iden = max_and_min_identity[0]-max_and_min_identity[1]
##         section = iden/10.0
##         xlabel = []
##         for i in range(0,11):
##             if not section:
##                 for i in range(0,5):
##                     xlabel.append(" ")
##                 xlabel.append(str(max_and_min_identity[1]+section*i))
##                 break
##             xlabel.append(str(max_and_min_identity[1]+section*i))
##         scale.x1.ticklabels = xlabel
##         scale.x1.ticks = (len(color)+1)
##         scale.x1.xrange = (0,1)
##         scale.x1.ticklabels_style["textangle"] = 45
##         scale.x1.ticklabels_style["fontsize"] = 2
##         scale.x1.draw_spine = 0
##         scale.x1.draw_ticks = 0
##         scale.x2.draw_ticks = 0
##         scale.y.draw_nothing = 1
##         scale.aspect_ratio = 2/10.0
##         scale.title = 'Scale of identity'

##         n = 1    
##         l,j,k = 0,0.1,0
##         for i in range(10):
##             if not section:
##                 seg = biggles.Curve([k,k+n],[0,0],color=color[i])
##                 scale.add(seg)
##                 break
##             else:
##                 seg = biggles.Curve([k,k+n],[0,0],color=color[i])
##                 scale.add(seg)
##                 k = k+n

##         t1 = biggles.Table(2,1)
##         t1[0,0] = f
##         t1[1,0] = scale
##         t1.cellspacing = -12
##         t1.cellpadding = 55

##         if not os.path.exists('images'):
##             os.system('mkdir images')

##         if title[0]=="global":
##             f.write_img(700,700, "images/"+self.file+"-global.png")
##             t1.write_img(700,700, "images/"+self.file+"-global01.png")
##         elif title[0]=="filtered": 
##             f.write_img(700,700, "images/"+self.file+"-filtered.png")
##             t1.write_img(700,700, "images/"+self.file+"-filtered01.png")
##         elif title[0]=="reverse":
##             f.write_img(700,700, "images/"+self.file+"-filtered-reverse.png")
##             t1.write_img(700,700, "images/"+self.file+"-filtered-reversed01.png")
##         elif title[0]=="modified":
##             f.write_img(700,700, "images/"+self.file+"-filtered-modified.png")
##             t1.write_img(700,700, "images/"+self.file+"-filtered-modified1.png")
##         else:
##             t1.write_img(700,700, "images/"+self.file+".png")

##         t1.show()
##         #f.show()
